'use strict';

var createEventSubject = require('./event-subject');
var makePropsObservable = require('./props');
var CompositeDisposableRx4 = require('./CompositeDisposableRx4');

module.exports = function createAdapter() {
  return {
    createEventSubject: createEventSubject,
    makePropsObservable: makePropsObservable,
    CompositeDisposable: CompositeDisposableRx4,
    next: function next(observer, value) {
      return observer.onNext(value);
    },
    complete: function complete(observer) {
      return observer.onCompleted();
    },
    isObservable: function isObservable(observable) {
      return observable && typeof observable.subscribe === 'function';
    }
  };
};