'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var CompositeDisposable = function () {
  function CompositeDisposable() {
    _classCallCheck(this, CompositeDisposable);

    this.disposables = [];
  }

  _createClass(CompositeDisposable, [{
    key: 'add',
    value: function add(subscription) {
      this.disposables.push(subscription);
    }
  }, {
    key: 'unsubscribe',
    value: function unsubscribe() {
      if (this.disposables === null) {
        throw new Error('Already disposed');
      }
      for (var i = 0; i < this.disposables.length; i++) {
        var sub = this.disposables[i];
        if (sub.unsubscribe) {
          sub.unsubscribe();
        } else if (typeof sub === 'function') {
          sub();
        }
      }
      this.disposables = null;
    }
  }]);

  return CompositeDisposable;
}();

module.exports = CompositeDisposable;