'use strict';

var createEventSubject = require('./event-subject');
var makePropsObservable = require('./props');
var CompositeDisposable = require('./CompositeDisposable');

module.exports = function createAdapter() {
  return {
    createEventSubject: createEventSubject,
    makePropsObservable: makePropsObservable,
    CompositeDisposable: CompositeDisposable,
    next: function next(observer, value) {
      return observer.next(value);
    },
    complete: function complete(observer) {
      return observer.complete();
    },
    isObservable: function isObservable(observable) {
      return observable && typeof observable.subscribe === 'function';
    }
  };
};